import { DomPopmotionPoser, DomPopmotionConfig } from 'popmotion-pose/lib/types';
export declare type ChildRegistration = {
    element: Element;
    poseConfig: DomPopmotionConfig;
    onRegistered: (poser: DomPopmotionPoser) => void;
};
export declare type CurrentPose = string | string[];
export declare type PoseContextProps = {
    registerChild?: (props: ChildRegistration) => void;
    onUnmount?: (child: DomPopmotionPoser) => any;
    getInitialPoseFromParent?: () => CurrentPose;
    getParentPoseConfig?: () => DomPopmotionConfig;
};
export declare type PoseElementProps = {
    children?: any;
    pose?: CurrentPose;
    _pose?: CurrentPose;
    initialPose?: CurrentPose;
    withParent?: boolean;
    onValueChange?: {
        [key: string]: (v: any) => any;
    };
    innerRef?: (el: Element) => any;
    [key: string]: any;
} & PoseContextProps;
export declare type PoseElementInternalProps = PoseElementProps & {
    elementType: any;
    poseConfig: DomPopmotionConfig;
};
export declare type PopStyle = {
    position: 'absolute';
    top: number;
    left: number;
    width: number;
    height: number;
};
